Package com.google.android.exoplayer2.database

## Interface DatabaseProvider

- All Known Implementing Classes:
    `DefaultDatabaseProvider`, `ExoDatabaseProvider`, `StandaloneDatabaseProvider`

      public interface DatabaseProvider

  Provides `SQLiteDatabase` instances to media library components, which may read and write tables prefixed with `TABLE_PREFIX`.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `TABLE_PREFIX` | Prefix for tables that can be read and written by media library components.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SQLiteDatabase` | `getReadableDatabase()` | Creates and/or opens a database.
    `SQLiteDatabase` | `getWritableDatabase()` | Creates and/or opens a database that will be used for reading and writing.

- - ### Field Detail

    - #### TABLE_PREFIX

          static final String TABLE_PREFIX

      Prefix for tables that can be read and written by media library components.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getWritableDatabase

          SQLiteDatabase getWritableDatabase()

      Creates and/or opens a database that will be used for reading and writing.

      Once opened successfully, the database is cached, so you can call this method every time you need to write to the database. Errors such as bad permissions or a full disk may cause this method to fail, but future attempts may succeed if the problem is fixed.

      Returns:
        A read/write database object.
      Throws:
        `SQLiteException` - If the database cannot be opened for writing.

    - #### getReadableDatabase

          SQLiteDatabase getReadableDatabase()

      Creates and/or opens a database. This will be the same object returned by `getWritableDatabase()` unless some problem, such as a full disk, requires the database to be opened read-only. In that case, a read-only database object will be returned. If the problem is fixed, a future call to `getWritableDatabase()` may succeed, in which case the read-only database object will be closed and the read/write object will be returned in the future.

      Once opened successfully, the database is cached, so you can call this method every time you need to read from the database.

      Returns:
        A database object valid until `getWritableDatabase()` is called.
      Throws:
        `SQLiteException` - If the database cannot be opened.